"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeClientIndex = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const getModelNames_1 = require("./getModelNames");
const getServiceNames_1 = require("./getServiceNames");
/**
 * Generate the OpenAPI client index file using the Handlebar template and write it to disk.
 * The index file just contains all the exports you need to use the client as a standalone
 * library. But yuo can also import individual models and services directly.
 * @param client Client object, containing, models, schemas and services.
 * @param templates The loaded handlebar templates.
 * @param outputPath Directory to write the generated files to.
 * @param exportServices: Generate services.
 * @param exportSchemas: Generate schemas.
 */
function writeClientIndex(client, templates, outputPath, exportServices, exportSchemas) {
    fs.writeFileSync(path.resolve(outputPath, 'index.ts'), templates.index({
        exportServices,
        exportSchemas,
        server: client.server,
        version: client.version,
        models: getModelNames_1.getModelNames(client.models),
        services: getServiceNames_1.getServiceNames(client.services),
    }));
}
exports.writeClientIndex = writeClientIndex;
